package ar.com.trabajos.broker.client.view;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;

import ar.com.trabajos.broker.shared.entities.CotizacionDTO;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiTemplate;
import com.google.gwt.user.cellview.client.CellTable;
import com.google.gwt.user.cellview.client.HasKeyboardSelectionPolicy.KeyboardSelectionPolicy;
import com.google.gwt.user.cellview.client.SimplePager;
import com.google.gwt.user.cellview.client.SimplePager.TextLocation;
import com.google.gwt.user.cellview.client.TextColumn;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.view.client.AsyncDataProvider;
import com.google.gwt.view.client.HasData;

import dacite.DBAnnotation;

public class AdminViewImpl extends Composite implements AdminView {

	@UiTemplate("AdminView.ui.xml")
	interface AdminUiBinder extends UiBinder<Widget, AdminViewImpl> {}
	private static AdminUiBinder uiBinder = 
			GWT.create(AdminUiBinder.class);


	@UiField
	CellTable<CotizacionDTO> cotizacionesTable;
	@UiField(provided = true)
	SimplePager pager;
	private AsyncDataProvider<CotizacionDTO> provider;
	private Presenter presenter;
	private final String user;
	private final String password;
	
	public AdminViewImpl(String user, String password) {
		this.user=user;
		this.password=password;
		SimplePager.Resources pagerResources = GWT.create(SimplePager.Resources.class);
		pager = new SimplePager(TextLocation.CENTER, pagerResources, false, 0, true);
		pager.setPageSize(10);
		
		initWidget(uiBinder.createAndBindUi(this));
		cotizacionesTable.setKeyboardSelectionPolicy(KeyboardSelectionPolicy.ENABLED);
		pager.setDisplay(cotizacionesTable);
		
		TextColumn<CotizacionDTO> nombreApellidoColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getNombreApellido();
			}
		};
		cotizacionesTable.addColumn(nombreApellidoColumn, "Nombre y Apellido");

		TextColumn<CotizacionDTO> empresaColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getEmpresa();
			}
		};	    
		cotizacionesTable.addColumn(empresaColumn, "Empresa");

		TextColumn<CotizacionDTO> correoColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getCorreo();
			}
		};
		cotizacionesTable.addColumn(correoColumn, "Correo");

		TextColumn<CotizacionDTO> telefonoColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getTelefono();
			}
		};
		cotizacionesTable.addColumn(telefonoColumn, "Telefono");
		
		TextColumn<CotizacionDTO> edadColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return Integer.toString(object.getEdad());
			}
		};
		cotizacionesTable.addColumn(edadColumn, "Edad");
		
		TextColumn<CotizacionDTO> provinciaColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getProvincia();
			}
		};
		cotizacionesTable.addColumn(provinciaColumn, "Provincia");
		
		TextColumn<CotizacionDTO> marcaColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getMarca();
			}
		};
		cotizacionesTable.addColumn(marcaColumn, "Marca");

		TextColumn<CotizacionDTO> descripcionColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getModeloAuto();
			}
		};
		cotizacionesTable.addColumn(descripcionColumn, "Descripción");
		
		TextColumn<CotizacionDTO> fechaColumn = new TextColumn<CotizacionDTO>() {
			public String getValue(CotizacionDTO object) {
				return object.getFecha().toString();
			}
		};
		cotizacionesTable.addColumn(fechaColumn, "Fecha");

	}

	public void actualizarTabla(int start, List<CotizacionDTO> cotizaciones){
		provider.updateRowData(start, cotizaciones);
//		cotizacionesTable.setRowData(cotizaciones);
//		provider.updateRowData(start, values)
	}

	public void setPresenter(Presenter presenter) {
		this.presenter = presenter;
		setUpProvider();
	}

	private void setUpProvider() {
		//  Associate an async data provider to the table
		provider = new AsyncDataProvider<CotizacionDTO>() {
			protected void onRangeChanged(HasData<CotizacionDTO> display) {
				final int start = display.getVisibleRange().getStart();
				int length = display.getVisibleRange().getLength();
    				presenter.obtenerCotizacion(user, password, start, length);


			}
		};
		
	}

	public Widget asWidget() {
		return this;
	}

	public void setCantidadTotal(Integer result) {
		provider.updateRowCount(result, true);
		
	}

	public void loadData() {
		provider.addDataDisplay(cotizacionesTable);		
	}

	public void discount3(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select insuranced_year from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int insuranced_year = rs.getInt("insuranced_year");
			DBAnnotation.annoate("insuranced_year", "insurance", "insuranced_year", true);
			
			int discount;
			if(insuranced_year<30){
				discount = 2;
				String sql = "update insurance set discount = " + discount + 
						"where insuranced_year = " + insuranced_year + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("discount", "insurance", "discount", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}

